-- SQL Dump
-- Database: `registro_servizi`
-- 

-- --------------------------------------------------------

-- 
-- Struttura della tabella `cliente`
-- 

CREATE TABLE `cliente` (
  `cod` int(6) NOT NULL auto_increment,
  `ragsoc` char(30) NOT NULL default '',
  `indirizzo` char(30) default NULL,
  `telefono` char(15) default NULL,
  `part_iva` char(20) default NULL,
  `fax` char(15) default NULL,
  PRIMARY KEY  (`cod`),
  UNIQUE KEY `cod` (`cod`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 ;


-- 
-- Dump dei dati per la tabella `cliente`
-- 

INSERT INTO `cliente` (`ragsoc`, `indirizzo`, `telefono`, `part_iva`, `fax`) VALUES 
('118 GETTONE', 'VIA CA'' GRANDA - MILANO', '118', 'N/A', 'N/A'),
('118 H16', 'VIA CA'' GRANDA - MILANO', '118', 'N/A', 'N/A'),
('118 H24', 'VIA CA'' GRANDA - MILANO', '118', 'N/A', 'N/A'),
('118 AGGIUNTIVA', 'VIA CA'' GRANDA - MILANO', '118', 'N/A', 'N/A'),
('PRIVATO', 'UTENTE FITTIZZIO', 'N/A', 'N/A', 'N/A');



-- --------------------------------------------------------

-- 
-- Struttura della tabella `colonnine`
-- 

CREATE TABLE `colonnine` (
  `id` int(1) NOT NULL auto_increment,
  `colonnina` varchar(40) default NULL,
  `comune` varchar(20) default NULL,
  `latitudine` varchar(10) default NULL,
  `longitudine` varchar(10) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=38 ;


-- 
-- Dump dei dati per la tabella `colonnine`
-- 

INSERT INTO `colonnine` (`id`, `colonnina`, `comune`, `longitudine`, `latitudine`) VALUES 
(1, 'CERTOSA/LAGHI', 'MILANO','9.13072','45.49972'),
(2, 'RUBICONE', 'MILANO', NULL, NULL),
(3, 'NIGRA', 'MILANO','9.17107','45.49667'),
(4, 'MACIACHINI', 'MILANO','9.18611','45.49750'),
(5, 'LORETO', 'MILANO','9.21694','45.48556'),
(6, 'TESTI/RODI', 'MILANO','9.20611','45.51500'),
(7, 'OBERDAN', 'MILANO','9.20556','45.47474'),
(8, 'BAIAMONTI', 'MILANO','9.18167','45.48194'),
(9, 'BARACCA', 'MILANO','9.16528','45.46611'),
(10, 'FONTANA (DUOMO)', 'MILANO','9.19389','45.46361'),
(11, 'CARIOLI', 'MILANO','9.18222','45.46806'),
(12, 'CHINOTTO', 'MILANO','9.12806','45.46306'),
(13, 'CUOCO', 'MILANO',NULL, NULL),
(14, 'LOTTO', 'MILANO','9.14361','45.47972'),
(15, 'NAPOLI', 'MILANO','9.15472','45.45278'),
(16, 'BELFANTI', 'MILANO','9.17278','45.44389'),
(17, 'AGRIPPA', 'MILANO',NULL, NULL),
(18, '24 MAGGIO', 'MILANO','9.18028','45.45250'),
(19, 'TEL AVIV', 'MILANO',NULL, NULL),
(20, 'FIRENZE', 'MILANO','9.15633','45.48778'),
(21, 'GHANDI', 'RHO (MI)',NULL, NULL),
(22, 'CAMPANIA/22 MARZO', 'MILANO','9.22361','45.46222'),
(23, 'CHIARADIA', 'MILANO','9.19793','45.43694'),
(24, 'LORENTEGGIO / INGANNI', 'MILANO','9.12750','45.44722'),
(25, 'MIANI', 'MILANO','9.15500','45.43750'),
(26, 'MONZA/FINZI', 'MILANO','9.22222','45.50500'),
(27, 'MEDAGLIE D''ORO', 'MILANO','9.20194','45.45222'),
(28, 'OBERDAN', 'MILANO','9.20556','45.47474'),
(29, 'OVIDIO', 'MILANO',NULL, NULL),
(30, '4� NOVEMBRE', 'MILANO','9.20222','45.48667'),
(31, 'ABBIATEGRASSO', 'MILANO','9.17748','45.43000'),
(32, 'GHIRLANDAIO', 'MILANO','9.14639','45.46667'),
(33, 'BOLOGNA','MILANO','9.22379','45.44444'),
(34, 'BOTTINI','MILANO','9.23630','45.48472'),
(35, 'PALMANOVA/CARNIA', 'MILANO','9.23583','45.49528'),
(36, '5 GIORNATE', 'MILANO', '9.20694','45.46222'),
(37, 'ASSIETTA/BOVISASCA', 'MILANO', '9.15639','45.51667');


-- --------------------------------------------------------

-- 
-- Struttura della tabella `costo`
-- 

CREATE TABLE `costo` (
  `id` int(2) NOT NULL auto_increment,
  `cod` int(2) NOT NULL,
  `costo_fisso` decimal(4,2) NOT NULL default '0.00',
  `costo_km` decimal(4,2) default '0.00',
  `secondo_trasportato` decimal(4,2) NOT NULL default '0.00',
  `fermo_macchina` decimal(4,2) NOT NULL default '0.00',
  `accompagnatore` decimal(4,2) default NULL,
  `sconto_soci` int(2) default NULL,
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=6 ;


-- 
-- Dump dei dati per la tabella `costo`
-- 

INSERT INTO `costo` (`id`, `cod`, `costo_fisso`, `costo_km`, `secondo_trasportato`, `fermo_macchina`, `accompagnatore`, `sconto_soci`) VALUES 
(1, 1, 29.44, 0.62, 9.30, 0.00, NULL, NULL),
(2, 5, 33.47, 0.74, 11.16, 24.17, NULL, 20),
(3, 3, 7.50, 0.65, 11.16, 5.00, 12.00, 20),
(4, 6, 17.00, 0.65, 11.16, 5.00, 12.00, 20),
(5, 7, 89.24, 0.00, 11.16, 24.17, NULL, 20);


-- --------------------------------------------------------

-- 
-- Struttura della tabella `gestvol`
-- 

CREATE TABLE `gestvol` (
  `id` int(4) NOT NULL auto_increment,
  `tessera` int(10) default '0',
  `cognome` varchar(30) NOT NULL default '',
  `ID_POSIZIONE` int(4),  
  `grado` char(2) NOT NULL default '',
  `dae` varchar(20) default NULL,
  `servizio` int(1) NOT NULL default '0',
  `aspett` int(1) NOT NULL default '0',
  `dimiss` int(1) NOT NULL default '0',
  `serv_int` int(1) default '0',
  `indisposto` int(1) default '0',
  `nome` varchar(20) default NULL,
  `nato_a` varchar(50) default NULL,
  `nato_il` date default '0000-00-00',
  `residenza` varchar(50) default NULL,
  `abitazione` varchar(50) default NULL,
  `cf` varchar(20) default NULL,
  `ci` varchar(20) default NULL,
  `patente` varchar(25) default NULL,
  `profession` varchar(20) default NULL,
  `data_pres` date default '0000-00-00',
  `data_acc` date default '0000-00-00',
  `data_dim` date default '0000-00-00',
  `foto` blob,
  `note` longtext,
  `all_ac` int(1) default '0',
  `all_pat` int(1) default '0',
  `all_cf` int(1) default '0',
  `all_ci` int(1) default '0',
  `sesso` char(1) NOT NULL default '',
  `studio` varchar(40) default NULL,
  `sq_fer` char(2) default NULL,
  `sq_fes` char(2) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;



-- --------------------------------------------------------

-- 
-- Struttura della tabella `mod_error`
-- 

CREATE TABLE `mod_error` (
  `id` int(2) NOT NULL default '0',
  `motivo` varchar(30) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


-- 
-- Dump dei dati per la tabella `mod_error`
-- 

INSERT INTO `mod_error` (`id`, `motivo`) VALUES 
(1, 'ERRORE OPERATIVO'),
(2, 'ADDESTRAMENTO'),
(3, 'ERRORE DI APPLICATIVO'),
(4, 'ERRORE DI SISTEMA'),
(5, 'ALTRO / VEDI NOTE');


-- --------------------------------------------------------

-- 
-- Struttura della tabella `modelli`
-- 

CREATE TABLE `modelli` (
  id int(11) NOT NULL auto_increment,
  identificativo varchar(18) default NULL,
  nominativo varchar(40) default NULL,
  indirizzo varchar(40) default NULL,
  cap int(5) default NULL,
  paese char(20) default NULL,
  motivo varchar(30) default NULL,
  luogo varchar(40) default NULL,
  luogo_citta varchar(20) default NULL,
  destinaz varchar(40) default NULL,
  destinaz_citta varchar(20) default NULL,
  km int(4) default '0',
  costo decimal(5,2) default '0.00',
  viaggio char(7) default NULL,
  richiedente char(30) default NULL,
  ora_serv varchar(8) default NULL,
  ora_fine varchar(8) default NULL,
  bolla char(5) default 'TRUE',
  PRIMARY KEY  (id)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 COMMENT='Presenta i modelli per i trasportati' AUTO_INCREMENT=1 ;


-- --------------------------------------------------------

-- 
-- Struttura della tabella `modpart`
-- 

CREATE TABLE `modpart` (
  `modo` char(10) NOT NULL default '',
  `id` int(1) NOT NULL auto_increment,
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=5 ;


-- 
-- Dump dei dati per la tabella `modpart`
-- 

INSERT INTO `modpart` (`modo`, `id`) VALUES 
('BIANCO', 0),
('VERDE', 1),
('GIALLO', 2),
('ROSSO', 3),
('NERO', 4);


-- --------------------------------------------------------

-- 
-- Struttura della tabella `oraridispo`
-- 

CREATE TABLE `oraridispo` (
  `id` int(5) NOT NULL auto_increment,
  `giorno` date default NULL,
  `mezzo` char(5) default NULL,
  `ora_inizio` varchar(8) default NULL,
  `ora_fine` varchar(8) default NULL,
  `convenzione` char(5) default NULL,
  `operativa` int(1) default '0',
  `posizione` varchar(30) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;



-- --------------------------------------------------------

-- 
-- Struttura della tabella `ortelio`
-- 

CREATE TABLE `ortelio` (
  `id` int(6) NOT NULL auto_increment,
  `citta` varchar(15) default NULL,
  `via` varchar(20) default NULL,
  `tavola` char(3) default NULL,
  `cord` varchar(8) default NULL,
  `note` longtext,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;


-- 
-- Dump dei dati per la tabella `ortelio`
-- 


-- --------------------------------------------------------

-- 
-- Struttura della tabella `ospedali`
-- 

CREATE TABLE `ospedali` (
  `id` int(2) NOT NULL auto_increment,
  `ospedale` varchar(30) default NULL,
  `paese` varchar(30) default NULL,
  `latitudine` varchar(10) default NULL,
  `longitudine` varchar(10) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=38 ;


-- 
-- Dump dei dati per la tabella `ospedali`
-- 

INSERT INTO `ospedali` (`id`, `ospedale`, `paese`) VALUES 
(1, 'H. SALVINI', 'GARBAGNATE M.SE (MI)'),
(2, 'H. CADUTI BOLLATESI', 'BOLLATE (MI)'),
(3, 'H. SARONNO', 'SARONNO (VA)'),
(4, 'H. NIGUARDA CA GRANDA', 'MILANO (MI)'),
(5, 'H. CLINICA SAN CARLO', 'PADERNO D.NO (MI)'),
(6, 'H. SAN CARLO', 'MILANO (MI)'),
(7, 'H. SAN GERARDO', 'MONZA (MB)'),
(8, 'H. SANT''ANNA', 'COMO (CO)'),
(9, 'H. FATEBENEFRATELLI', 'MILANO (MI)'),
(10, 'H. RHO CIRCOLO', 'RHO (MI)'),
(11, 'H. SACCO', 'MILANO (MI)'),
(12, 'H. POLICLINICO', 'MILANO (MI)'),
(13, 'H. SAN PAOLO', 'MILANO (MI)'),
(14, 'H. SAN RAFFAELE', 'MILANO (MI)'),
(15, 'H. HUMANITAS', 'MILANO (MI)'),
(16, 'H. SANTA RITA', 'MILANO (MI)'),
(17, 'H. MULTIMEDICA', 'SESTO SAN GIOVANNI (MI)'),
(18, 'H. FORNAROLI', 'MAGENTA'),
(19, 'H. ALFIERI/MANGIAGALLI', 'MILANO (MI)'),
(20, 'H. GALEAZZI', 'MILANO (MI)'),
(21, 'H. CARDIOLOGICO MONZINO', 'MILANO (MI)'),
(22, 'H. MACEDONIO MELLONI', 'MILANO (MI)'),
(23, 'H. DE MARCHI', 'MILANO (MI)'),
(24, 'H. GAETANO PINI', 'MILANO (MI)'),
(25, 'H. VITTORE BUZZI', 'MILANO (MI)'),
(27, 'H. CLINICA SAN LUCA', 'MILANO (MI)'),
(28, 'H. CLINICA SANT''AMBROGIO', 'MILANO'),
(29, 'H. BASSINI', 'CINISELLO BALSAMO (MI)'),
(30, 'H. SESTO SAN GIOVANNI', 'SESTO SAN GIOVANNI (MI)'),
(31, 'H. OSPEDALE CIVILE', 'LEGNANO (MI)'),
(32, 'H. CASATI', 'PASSIRANA DI RHO (MI)'),
(33, 'H. GALMARINI', 'TRADATE (VA)'),
(34, 'H. BUSTO ARSIZIO', 'BUSTO ARSIZIO (VA)'),
(35, 'H. OSPEDALE CITTA'' DI DESIO', 'DESIO (MZ)'),
(36, 'H. ISTITUTO EUROPEO ONCOLOGIA', 'MILANO (MI)'),
(37, 'H. REGINA ELENA', 'MILANO (MI)');


-- --------------------------------------------------------

-- 
-- Struttura della tabella `park`
-- 

CREATE TABLE `park` (
  `id` int(5) NOT NULL auto_increment,
  `cod_auto` char(5) default NULL,
  `tipo` char(20) default NULL,
  `modello` char(20) default NULL,
  `targa` char(10) default NULL,
  `immatric` date default '0000-00-00',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;


-- 
-- Dump dei dati per la tabella `park`
-- 

INSERT INTO `park` (`id`, `cod_auto`, `tipo`, `modello`, `targa`, `immatric`) VALUES 
(1, '01', 'AMBULANZA', 'FIAT DUCATO', 'AA000BB', '0000-00-00');



-- --------------------------------------------------------

-- 
-- Struttura della tabella `password`
-- 

CREATE TABLE `password` (
  `id` int(2) NOT NULL auto_increment,
  `cod` char(2) NOT NULL default '',
  `app` char(10) NOT NULL default '',
  `password` char(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=5 ;


-- 
-- Dump dei dati per la tabella `password`
-- 

INSERT INTO `password` (`id`, `cod`, `app`, `password`) VALUES 
(1, '1', 'GESTVOL',md5('password')),
(2, '2', 'ELSERV',md5('password')),
(3, '3', 'ADMIN',md5('password')),
(4, '4', 'SOCI',md5('password'));


-- --------------------------------------------------------

-- 
-- Struttura della tabella `sequence`
-- 

CREATE TABLE `sequence` (
  `id` int(11) NOT NULL auto_increment,
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;


-- 
-- Dump dei dati per la tabella `sequence`
-- 

INSERT INTO `sequence` (`id`) VALUES 
(0);


-- --------------------------------------------------------

-- 
-- Struttura della tabella `servizi`
-- 

CREATE TABLE `servizi` (
  `id` int(6) NOT NULL auto_increment,
  `num` int(6) NOT NULL default '0',
  `tipo` varchar(30) NOT NULL default '',
  `cliente` varchar(30) default NULL,
  `oper118` varchar(20) default NULL,
  `num118` varchar(10) default NULL,
  `stato` varchar(25) default NULL,
  `luogo` varchar(50) default NULL,
  `luogo_citta` varchar(50) default NULL,
  `motivo` varchar(30) default NULL,
  `destinaz` varchar(50) default NULL,
  `destinaz_citta` varchar(50) default NULL,
  `cs` varchar(30) default NULL,
  `autista` varchar(30) default NULL,
  `milite` varchar(30) default NULL,
  `milite2` varchar(30) default NULL,
  `centralino` varchar(30) NOT NULL default '',
  `ora_posto` varchar(8) default NULL,
  `ora_caric` varchar(8) default NULL,
  `ora_dest` varchar(8) default NULL,
  `ora_lib` varchar(8) default NULL,
  `km` int(4) default '0',
  `mezzo` varchar(5) default NULL,
  `bolla` varchar(5) NOT NULL default '',
  `trasp_a` varchar(10) default NULL,
  `trasp_r` varchar(10) default NULL,
  `data_serv` date default '0000-00-00',
  `ora_serv` varchar(8) default NULL,
  `ora_part` varchar(8) default NULL,
  `cod_stato` int(4) default '0',
  `cod_serv` int(4) default '0',
  `ora_fine` varchar(8) default NULL,
  `note` blob,
  `deleted` int(1) default '0',
  `costo` decimal(5,2) default '0.00',
  `pagato` int(1) default '0',
  `num_fatt` varchar(5) default NULL,
  `fatturato` int(1) default '0',
  `riferimenti` varchar(50) default NULL,
  `DAE` varchar(5) NOT NULL default 'FALSE',
  `MSA` varchar(5) NOT NULL default 'FALSE',
  `MSAonB` varchar(5) NOT NULL default 'FALSE',
  `ELI` varchar(5) NOT NULL default 'FALSE',
  `VVF` varchar(5) NOT NULL default 'FALSE',
  `POLIZ` varchar(5) NOT NULL default 'FALSE',
  `VNOTE` varchar(5) NOT NULL default 'FALSE',
  `MSB` varchar(5) NOT NULL default 'FALSE',
  `bolla2` varchar(5) default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `num` (`num`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;


-- --------------------------------------------------------

-- 
-- Struttura della tabella `sq_feriale`
-- 

CREATE TABLE `sq_feriale` (
  `id_feriale` int(2) NOT NULL auto_increment,
  `cod` char(2) NOT NULL default '',
  `squadra` char(20) NOT NULL default '',
   PRIMARY KEY  (`id_feriale`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


-- 
-- Dump dei dati per la tabella `sq_feriale`
-- 

INSERT INTO `sq_feriale` (`cod`, `squadra`) VALUES 
('S1', 'LUNEDI NOTTE'),
('S2', 'MARTEDI NOTTE'),
('S3', 'MERCOLEDI NOTTE'),
('S4', 'GIOVEDI NOTTE'),
('S5', 'VENERDI NOTTE'),
('S6', 'SABATO MATTINA'),
('S7', 'SABATO NOTTE');


-- --------------------------------------------------------

-- 
-- Struttura della tabella `sq_festivi`
-- 

CREATE TABLE `sq_festivi` (
  `id_festivo` int(2) NOT NULL auto_increment,
  `cod` char(2) NOT NULL default '',
  `squadra` char(10) NOT NULL default '',
  PRIMARY KEY  (`id_festivo`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


-- 
-- Dump dei dati per la tabella `sq_festivi`
-- 

INSERT INTO `sq_festivi` (`cod`, `squadra`) VALUES 
('R1', 'FESTIVO 1'),
('R2', 'FESTIVO 2'),
('R3', 'FESTIVO 3'),
('R4', 'FESTIVO 4'),
('R5', 'FESTIVO 5');


-- --------------------------------------------------------

-- 
-- Struttura della tabella `stato`
-- 

CREATE TABLE `stato` (
  `id` int(4) NOT NULL auto_increment,
  `cod` char(2) NOT NULL default '',
  `statobolla` char(25) NOT NULL default '',
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=10 ;


-- 
-- Dump dei dati per la tabella `stato`
-- 

INSERT INTO `stato` (`id`, `cod`, `statobolla`) VALUES 
(1, '1', 'REGOLARE'),
(2, '0', 'RIFIUTO FIRMATO'),
(3, '0', 'RIFIUTO NON FIRMATO'),
(4, '0', 'SI ALLONTANA'),
(5, '0', 'VUOTO'),
(6, '5', 'INTERROTTA'),
(7, '6', 'EVACUATO CON ELISOCCORSO'),
(8, '4', 'DECEDUTO'),
(9, '6', 'EVACUATO DA ALTRO MSB');


-- --------------------------------------------------------

-- 
-- Struttura della tabella `studio`
-- 

CREATE TABLE `studio` (
  `cod` char(2) NOT NULL default '',
  `studio` char(40) NOT NULL default ''
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


-- 
-- Dump dei dati per la tabella `studio`
-- 

INSERT INTO `studio` (`cod`, `studio`) VALUES 
('NO', 'NESSUNO'),
('EL', 'ELEMENTARI'),
('MI', 'MEDIE INFERIORI'),
('MS', 'DIPLOMA'),
('LR', 'LAUREA'),
('DL', 'DIPLOMA DI LAUREA');


-- --------------------------------------------------------

-- 
-- Struttura della tabella `tipo_serv`
-- 

CREATE TABLE `tipo_serv` (
  `id` int(4) NOT NULL auto_increment,
  `tiposerv` char(20) NOT NULL default '',
  `cod` int(2) NOT NULL default '0',
  KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=9 ;


-- 
-- Dump dei dati per la tabella `tipo_serv`
-- 

INSERT INTO `tipo_serv` (`id`, `tiposerv`, `cod`) VALUES 
(1, '118', 1),
(2, 'TRASPORTO', 3),
(3, 'STAZIONAMENTO', 2),
(4, 'TRASPORTO AMBULANZA', 5),
(5, 'AUTOMEDICA', 4),
(6, 'TRASPORTO DISABILI', 6),
(7, 'CMR', 7),
(8, 'GUARDIA MEDICA', 8);


-- --------------------------------------------------------

-- 
-- Struttura della tabella `trasport`
-- 

CREATE TABLE `trasport` (
  `id` int(5) NOT NULL auto_increment,
  `num` int(6) NOT NULL default '0',
  `nominativo` char(40) NOT NULL default '',
  `indirizzo` char(40) NOT NULL default '',
  `cap` int(5) default '0',
  `paese` char(20) NOT NULL default '',
  `datan` date default '0000-00-00',
  `socio` int(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;




/*==============================================================*/
/* Table: POSIZIONE                                             */
/*==============================================================*/
create table posizione
(
   ID_POSIZIONE                   int(2)                       not null auto_increment,
   COD                            char(2)                        not null,
   POSIZIONE                      varchar(20),
   primary key (ID_POSIZIONE)
)
type = InnoDB;


INSERT INTO `posizione` (`cod`, `posizione`) VALUES 
('VV', 'VOLONTARIO'),
('SD', 'DIURNO/DIPENDENTE'),
('OB', 'OBIETTORE');
 

/*==============================================================*/
/* Table: GRADO                                                 */
/*==============================================================*/
create table grado
(
   ID_GRADO                   		int(2)                       not null auto_increment,
   COD                            char(2)                      not null,
   GRADO                     		  char(45),
   primary key (ID_GRADO)
)
type = InnoDB;


INSERT INTO `grado` (`cod`, `GRADO`) VALUES 
('CN', 'CENTRALINO'),
('AL', 'ALLIEVO'),
('ML', 'MILITE'),
('CS', 'CAPO SERVIZIO'),
('AM', 'AUTISTA GRADO 1 (MACCHINA)'),
('TT', 'AUTISTA GRADO 2 (TRASPORTO)'),
('AT', 'AUTISTA GRADO 3 (URGENZA)');


/*==============================================================*/
/* Table: SOCI                                                  */
/*==============================================================*/
create table soci
(
   ID_SOCIO                       int(4)                         not null auto_increment,
   TESSERA                        int(6)                    		 UNIQUE not null,
   NOMINATIVO                     varchar(40)                    not null,
   INDIRIZZO                      varchar(50)                    not null,
   CAP                            int(5)                         not null,
   CITTA                          varchar(40)                    not null,
   PROV                           varchar(2)                     not null,
   ZONA				  int(2),
   LUOGO_DI_NASCITA               varchar(40)                    not null,
   DATA_DI_NASCITA                date                           not null,
   CF                             varchar(20),
   DATA_TESSERAMENTO              date,
   TRATTAMENTO_DATI               bool,
   TELEFONO                       varchar(40)                    not null,
   PROFESSIONE                    varchar(20),
   primary key (ID_SOCIO)
)
type = InnoDB;



/*==============================================================*/
/* Index: "REFERENCE_2_FK"                                            */
/*==============================================================*/
create index REFERENCE_2_FK ON gestvol (ID_POSIZIONE);


alter table gestvol add constraint FK_REFERENCE_2 foreign key (ID_POSIZIONE)
      references posizione (ID_POSIZIONE) on delete restrict on update restrict;


/*==============================================================*/
/* Table: SOCI_FAMILIARI                                        */
/*==============================================================*/
create table soci_familiari
(
   ID_FAMILIARI                   int(4)                         auto_increment not null,
   ID_SOCIO                       int(4),
   FAMILIARE                      varchar(50)                    not null,
   primary key (ID_FAMILIARI)
)
type = InnoDB;


/*==============================================================*/
/* Index: "REFERENCE_3_FK"                                            */
/*==============================================================*/
create index REFERENCE_3_FK on soci_familiari (ID_SOCIO);


/*==============================================================*/
/* Table: SOCI_RINNOVI                                          */
/*==============================================================*/
create table soci_rinnovi
(
   ID_SOCIO                       int(4),
   ID_RINNOVO                     int(4)                         auto_increment not null,
   ANNO                           int(4),
   QUOTA                          float(5,2),
   DATA_RINNOVO                   date,
   primary key (ID_RINNOVO)
)
type = InnoDB;


/*==============================================================*/
/* Index: "REFERENCE_4_FK"                                      */
/*==============================================================*/
create index REFERENCE_4_FK on soci_rinnovi (ID_SOCIO);



alter table soci_familiari add constraint FK_REFERENCE_3 foreign key (ID_SOCIO)
      references soci (ID_SOCIO) on delete cascade on update restrict;


alter table soci_rinnovi add constraint FK_REFERENCE_4 foreign key (ID_SOCIO)
      references soci (ID_SOCIO) on delete cascade on update restrict;



/*==============================================================*/

DROP TABLE IF EXISTS  sequence ;

DELIMITER //

CREATE TABLE sequence (
  id int(11) NOT NULL auto_increment,
  KEY id (id)
) ENGINE=InnoDB DEFAULT CHARSET=latin1

//

DELIMITER // 

CREATE PROCEDURE generate_sequence_number(OUT param1 INT)

BEGIN
    UPDATE `sequence` SET id=LAST_INSERT_ID(id+1);
    SELECT LAST_INSERT_ID() INTO param1 ;
END; //

DELIMITER ; 