unit Pickdate;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  SysUtils, StdCtrls, Grids, Calendar, ExtCtrls, ComCtrls, dialogs, dmServizi;

type
  TBrDateForm = class(TForm)
    Calendar1: TCalendar;
    TitleLabel: TLabel;
    PrevMonthBtn: TSpeedButton;
    NextMonthBtn: TSpeedButton;
    EditYr: TEdit;
    Label1: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Label2: TLabel;
    Okbtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    procedure PrevMonthBtnClick(Sender: TObject);
    procedure NextMonthBtnClick(Sender: TObject);
    procedure Calendar1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EditYrChange(Sender: TObject);
    procedure Calendar1DblClick(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
  private
    FDmServizi: TdmdServizi;
    procedure SetDate(CalDate: TDateTime);
    function GetDate: TDateTime;
  public
    property CalDate: TDateTime read GetDate write SetDate;
  end;

var
  BrDateForm: TBrDateForm;

implementation

uses UntMod;

{$R *.DFM}

procedure TBrDateForm.SetDate(CalDate: TDateTime);
begin
  Calendar1.CalendarDate := CalDate;
  if Calendar1.Year < 1910 then
    Calendar1.CalendarDate := Date;
end;

function TBrDateForm.GetDate: TDateTime;
begin
  Result := Calendar1.CalendarDate;
end;

procedure TBrDateForm.PrevMonthBtnClick(Sender: TObject);
begin
  Calendar1.PrevMonth;
end;

procedure TBrDateForm.NextMonthBtnClick(Sender: TObject);
begin
  Calendar1.NextMonth;
end;

procedure TBrDateForm.Calendar1Change(Sender: TObject);
begin
  TitleLabel.Caption := FormatDateTime('MMMM, YYYY', Calendar1.CalendarDate);
  EditYr.Text := IntToStr(Calendar1.Year);
end;

procedure TBrDateForm.FormShow(Sender: TObject);
begin
  EditYr.Text := IntToStr(Calendar1.Year)
end;

procedure TBrDateForm.EditYrChange(Sender: TObject);
begin
  Calendar1.Year := StrToInt(EditYr.Text)
end;

procedure TBrDateForm.Calendar1DblClick(Sender: TObject);
begin
  OkBtn.Click
end;

procedure TBrDateForm.OkBtnClick(Sender: TObject);
begin
  FDmServizi.TblServizi.FieldByName('DATA_SERV').asdatetime :=
    Calendar1.CalendarDate;
  BrDateForm.Close;
end;

procedure TBrDateForm.ExitBtnClick(Sender: TObject);
begin
  BrDateForm.Close;
end;

end.
