unit UntCommon;

interface

uses sysutils, dmMod, IniFiles, Windows, ShlObj, dialogs,  ComCtrls, UntAuto,
    Controls;

type
  TCoordinate = array[0..2] of string;

 function CapitaliseString(str : String; OnlyFirstWord : Boolean) : String;
 function GetCoordinate(tabella, colonna, chiave : string) : TCoordinate;
 function GetConfString(sezione,chiave : string): string;
 function GetConfBool(sezione,chiave : string) : Boolean;
 procedure SetConfString(sezione,chiave,valore : string);
 procedure SetConfBool(sezione,chiave : string; valore :  Boolean);
 procedure NotImplemented;
 function GetSpecialFolder(const CSIDL : integer) : string;
 function CheckPassword(password, application : string ) : Boolean;
 function ChangePassword(newpassword, application : string ) : Boolean;
 function GetSection(name : string) : string;
 procedure CambiaTabName(Mezzo, Missione : string);
 function Confirm(Msg: string): Boolean;

implementation


function Confirm(Msg: string): Boolean;
begin
  Result := MessageDlg(Msg, mtConfirmation, mbYesNo, 0) = mrYes;
end;

procedure NotImplemented;
begin
      MessageDlg('Spiacente! Funzionalit ancora non implementata.', mtWarning,
        [mbOk], 0);
end;

procedure CambiaTabName(Mezzo, Missione : string);
var oldstring, newstring : string;
begin
  oldstring := FrmAuto.TabControl1.Tabs.Strings[FrmAuto.TabControl1.tabindex];
  newstring := ' '+ ModServ.SIGLA + Mezzo  + '  ('+ Missione + ')';

  FrmAuto.TabControl1.Tabs.Strings[FrmAuto.TabControl1.tabindex] :=
  StringReplace(oldstring, oldstring , newstring, [rfReplaceAll, rfIgnoreCase]);
end;

function GetSection(name : string ) : string;
begin

  if (name = 'Gestione Personale') then
    Result := 'GESTVOL';

  if (name = 'Elenco Servizi') then
    Result := 'ELSERV';

  if (name = 'Configurazioni e Manutenzione') then
    Result := 'ADMIN';

  if (name = 'Esportazione Soci') then
    Result := 'SOCI';

end;

function CheckPassword(password, application : string ) : Boolean;
begin
  modserv.QryFind.SQL.Clear;
  modserv.QryFind.SQL.Add('select * from password where');
  modserv.QryFind.SQL.Add('password=md5('''+ password + ''')');
  modserv.QryFind.SQL.Add(' and app=''' + application + '''');

  modserv.QryFind.Close;
  modserv.QryFind.Open;

  if modserv.qryfind.RecordCount = 1 then
    result := True
  else
    result := False;

end;

function ChangePassword(newpassword, application : string ) : Boolean;
begin
  modserv.QryFind.SQL.Clear;
  modserv.QryFind.SQL.Add('UPDATE password SET');
  modserv.QryFind.SQL.Add('password=md5('''+ newpassword + ''')');
  modserv.QryFind.SQL.Add(' WHERE app=''' + application + '''');

  modserv.QryFind.Close;
  modserv.QryFind.ExecSQL;

  if CheckPassword(newpassword,application) then
    result := True
  else
    result := False;

end;

function CapitaliseString(str : String; OnlyFirstWord :Boolean) : String;
var
  i : integer;
begin
  if str <> '' then begin
      str := Lowercase(str);
      str[1] := Uppercase(str[1])[1];

      if Not OnlyFirstWord then begin
        for i := 1 to Length(str) do begin
            if (str[i] = ' ') and (Length(Str) > i+1) then
               if Str[i+1] <> ' ' then
                  Str[i+1] := Uppercase(Str[i+1])[1]
        end;
      end;
  end;
  result := str;
end;

function GetCoordinate(tabella, colonna, chiave : string): TCoordinate;
  var Coordinate : TCoordinate;
begin
       ModServ.QryFind.SQL.Clear;
       ModServ.QryFind.SQL.Add('select latitudine,longitudine from ' + tabella +
       ' where ' + colonna + '="'+ chiave +'"');
       ModServ.QryFind.Open;
       Coordinate[0] := chiave;
       Coordinate[1] := ModSErv.QryFind.FieldByName('latitudine').AsString;
       Coordinate[2] := ModSErv.QryFind.FieldByName('longitudine').AsString;
       ModServ.QryFind.Close;
       ModServ.QryFind.SQL.Clear;

       Result := Coordinate;
end;

function GetConfString(sezione,chiave : string): string;
begin
  if FileExists(ModServ.FConfFile) then
  begin
    with TIniFile.Create(ModServ.FConfFile) do
    try
       result := ReadString(sezione,chiave, '')
    finally
      Free;
    end;
  end;
end;

Procedure SetConfString(sezione,chiave,valore: string);
begin

  if FileExists(ModServ.FConfFile) then
  begin
    with TIniFile.Create(ModServ.FConfFile) do
    try
       WriteString(sezione,chiave,valore)
    finally
      Free;
    end;
  end;
end;

function GetConfBool(sezione,chiave : string): Boolean;
begin
  if FileExists(ModServ.FConfFile) then
  begin
    with TIniFile.Create(ModServ.FConfFile) do
    try
       result := ReadBool(sezione,chiave, False)
    finally
      Free;
    end;
  end;
end;

 procedure SetConfBool(sezione,chiave : string; valore :  Boolean);
begin

  if FileExists(ModServ.FConfFile) then
  begin
    with TIniFile.Create(ModServ.FConfFile) do
    try
       WriteBool(sezione,chiave, valore)
    finally
      Free;
    end;
  end;
end;

function GetSpecialFolder(const CSIDL : integer) : string;
var RecPath : PAnsiChar;
{
CSIDL Constants
---------------

CSIDL_FLAG_CREATE (0x8000)
Version 5.0. Combine this CSIDL with any of the following CSIDLs to force the creation of the associated folder.

CSIDL_ADMINTOOLS (0x0030)
Version 5.0. The file system directory that is used to store administrative tools for an individual user. The Microsoft Management Console (MMC) will save customized consoles to this directory, and it will roam with the user.

CSIDL_ALTSTARTUP (0x001d)
The file system directory that corresponds to the user's nonlocalized Startup program group.

CSIDL_APPDATA (0x001a)
Version 4.71. The file system directory that serves as a common repository for application-specific data. A typical path is C:\Documents and Settings\username\Application Data. This CSIDL is supported by the redistributable Shfolder.dll for systems that do not have the Microsoft Internet Explorer 4.0 integrated Shell installed.

CSIDL_BITBUCKET (0x000a)
The virtual folder containing the objects in the user's Recycle Bin.

CSIDL_CDBURN_AREA (0x003b)
Version 6.0. The file system directory acting as a staging area for files waiting to be written to CD. A typical path is C:\Documents and Settings\username\Local Settings\Application Data\Microsoft\CD Burning.

CSIDL_COMMON_ADMINTOOLS (0x002f)
Version 5.0. The file system directory containing administrative tools for all users of the computer.

CSIDL_COMMON_ALTSTARTUP (0x001e)
The file system directory that corresponds to the nonlocalized Startup program group for all users. Valid only for Microsoft Windows NT systems.

CSIDL_COMMON_APPDATA (0x0023)
Version 5.0. The file system directory containing application data for all users. A typical path is C:\Documents and Settings\All Users\Application Data.

CSIDL_COMMON_DESKTOPDIRECTORY (0x0019)
The file system directory that contains files and folders that appear on the desktop for all users. A typical path is C:\Documents and Settings\All Users\Desktop. Valid only for Windows NT systems.

CSIDL_COMMON_DOCUMENTS (0x002e)
The file system directory that contains documents that are common to all users. A typical paths is C:\Documents and Settings\All Users\Documents. Valid for Windows NT systems and Microsoft Windows 95 and Windows 98 systems with Shfolder.dll installed.

CSIDL_COMMON_FAVORITES (0x001f)
The file system directory that serves as a common repository for favorite items common to all users. Valid only for Windows NT systems.

CSIDL_COMMON_MUSIC (0x0035)
Version 6.0. The file system directory that serves as a repository for music files common to all users. A typical path is C:\Documents and Settings\All Users\Documents\My Music.

CSIDL_COMMON_PICTURES (0x0036)
Version 6.0. The file system directory that serves as a repository for image files common to all users. A typical path is C:\Documents and Settings\All Users\Documents\My Pictures.

CSIDL_COMMON_PROGRAMS (0x0017)
The file system directory that contains the directories for the common program groups that appear on the Start menu for all users. A typical path is C:\Documents and Settings\All Users\Start Menu\Programs. Valid only for Windows NT systems.

CSIDL_COMMON_STARTMENU (0x0016)
The file system directory that contains the programs and folders that appear on the Start menu for all users. A typical path is C:\Documents and Settings\All Users\Start Menu. Valid only for Windows NT systems.

CSIDL_COMMON_STARTUP (0x0018)
The file system directory that contains the programs that appear in the Startup folder for all users. A typical path is C:\Documents and Settings\All Users\Start Menu\Programs\Startup. Valid only for Windows NT systems.

CSIDL_COMMON_TEMPLATES (0x002d)
The file system directory that contains the templates that are available to all users. A typical path is C:\Documents and Settings\All Users\Templates. Valid only for Windows NT systems.

CSIDL_COMMON_VIDEO (0x0037)
Version 6.0. The file system directory that serves as a repository for video files common to all users. A typical path is C:\Documents and Settings\All Users\Documents\My Videos.

CSIDL_CONTROLS (0x0003)
The virtual folder containing icons for the Control Panel applications.

CSIDL_COOKIES (0x0021)
The file system directory that serves as a common repository for Internet cookies. A typical path is C:\Documents and Settings\username\Cookies.

CSIDL_DESKTOP (0x0000)
The virtual folder representing the Windows desktop, the root of the namespace.

CSIDL_DESKTOPDIRECTORY (0x0010)
The file system directory used to physically store file objects on the desktop (not to be confused with the desktop folder itself). A typical path is C:\Documents and Settings\username\Desktop.

CSIDL_DRIVES (0x0011)
The virtual folder representing My Computer, containing everything on the local computer: storage devices, printers, and Control Panel. The folder may also contain mapped network drives.

CSIDL_FAVORITES (0x0006)
The file system directory that serves as a common repository for the user's favorite items. A typical path is C:\Documents and Settings\username\Favorites.

CSIDL_FONTS (0x0014)
A virtual folder containing fonts. A typical path is C:\Windows\Fonts.

CSIDL_HISTORY (0x0022)
The file system directory that serves as a common repository for Internet history items.

CSIDL_INTERNET (0x0001)
A virtual folder representing the Internet.

CSIDL_INTERNET_CACHE (0x0020)
Version 4.72. The file system directory that serves as a common repository for temporary Internet files. A typical path is C:\Documents and Settings\username\Local Settings\Temporary Internet Files.

CSIDL_LOCAL_APPDATA (0x001c)
Version 5.0. The file system directory that serves as a data repository for local (nonroaming) applications. A typical path is C:\Documents and Settings\username\Local Settings\Application Data.

CSIDL_MYDOCUMENTS (0x000c)
Version 6.0. The virtual folder representing the My Documents desktop item. This should not be confused with CSIDL_PERSONAL, which represents the file system folder that physically stores the documents.

CSIDL_MYMUSIC (0x000d)
The file system directory that serves as a common repository for music files. A typical path is C:\Documents and Settings\User\My Documents\My Music.

CSIDL_MYPICTURES (0x0027)
Version 5.0. The file system directory that serves as a common repository for image files. A typical path is C:\Documents and Settings\username\My Documents\My Pictures.

CSIDL_MYVIDEO (0x000e)
Version 6.0. The file system directory that serves as a common repository for video files. A typical path is C:\Documents and Settings\username\My Documents\My Videos.

CSIDL_NETHOOD (0x0013)
A file system directory containing the link objects that may exist in the My Network Places virtual folder. It is not the same as CSIDL_NETWORK, which represents the network namespace root. A typical path is C:\Documents and Settings\username\NetHood.

CSIDL_NETWORK (0x0012)
A virtual folder representing Network Neighborhood, the root of the network namespace hierarchy.

CSIDL_PERSONAL (0x0005)
The file system directory used to physically store a user's common repository of documents. A typical path is C:\Documents and Settings\username\My Documents. This should be distinguished from the virtual My Documents folder in the namespace, identified by CSIDL_MYDOCUMENTS. To access that virtual folder, use SHGetFolderLocation, which returns the ITEMIDLIST for the virtual location, or refer to the technique described in Managing the File System.

CSIDL_PRINTERS (0x0004)
The virtual folder containing installed printers.

CSIDL_PRINTHOOD (0x001b)
The file system directory that contains the link objects that can exist in the Printers virtual folder. A typical path is C:\Documents and Settings\username\PrintHood.

CSIDL_PROFILE (0x0028)
Version 5.0. The user's profile folder. A typical path is C:\Documents and Settings\username. Applications should not create files or folders at this level; they should put their data under the locations referred to by CSIDL_APPDATA or CSIDL_LOCAL_APPDATA.

CSIDL_PROFILES (0x003e)
Version 6.0. The file system directory containing user profile folders. A typical path is C:\Documents and Settings.

CSIDL_PROGRAM_FILES (0x0026)
Version 5.0. The Program Files folder. A typical path is C:\Program Files.

CSIDL_PROGRAM_FILES_COMMON (0x002b)
Version 5.0. A folder for components that are shared across applications. A typical path is C:\Program Files\Common. Valid only for Windows NT, Windows 2000, and Windows XP systems. Not valid for Windows Millennium Edition (Windows Me).

CSIDL_PROGRAMS (0x0002)
The file system directory that contains the user's program groups (which are themselves file system directories). A typical path is C:\Documents and Settings\username\Start Menu\Programs.

CSIDL_RECENT (0x0008)
The file system directory that contains shortcuts to the user's most recently used documents. A typical path is C:\Documents and Settings\username\My Recent Documents. To create a shortcut in this folder, use SHAddToRecentDocs. In addition to creating the shortcut, this function updates the Shell's list of recent documents and adds the shortcut to the My Recent Documents submenu of the Start menu.

CSIDL_SENDTO (0x0009)
The file system directory that contains Send To menu items. A typical path is C:\Documents and Settings\username\SendTo.

CSIDL_STARTMENU (0x000b)
The file system directory containing Start menu items. A typical path is C:\Documents and Settings\username\Start Menu.

CSIDL_STARTUP (0x0007)
The file system directory that corresponds to the user's Startup program group. The system starts these programs whenever any user logs onto Windows NT or starts Windows 95. A typical path is C:\Documents and Settings\username\Start Menu\Programs\Startup.

CSIDL_SYSTEM (0x0025)
Version 5.0. The Windows System folder. A typical path is C:\Windows\System32.

CSIDL_TEMPLATES (0x0015)
The file system directory that serves as a common repository for document templates. A typical path is C:\Documents and Settings\username\Templates.

CSIDL_WINDOWS (0x0024)
Version 5.0. The Windows directory or SYSROOT. This corresponds to the %windir% or %SYSTEMROOT% environment variables. A typical path is C:\Windows.
}
begin
  RecPath := StrAlloc(MAX_PATH);
  try
    FillChar(RecPath^,MAX_PATH,0);
    if SHGetSpecialFolderPath(0,RecPath,CSIDL,false) then begin
      result := RecPath;
    end else result := '';
    finally
    StrDispose(RecPath);
  end;
end;

end.
