unit UntDBDump;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, JvExControls, JvLabel, JvExStdCtrls, JvEdit, DB,
  DBTables, Mask, JvExMask,dateutils, ComCtrls, shellapi, JvToolEdit;

type
  TFrmDBDump = class(TForm)
    Button1: TButton;
    QryResetDB: TQuery;
    pagemantdb: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    TabSheet3: TTabSheet;
    GroupBox1: TGroupBox;
    Image1: TImage;
    Label3: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label11: TLabel;
    Bevel1: TBevel;
    Label7: TLabel;
    chk2: TCheckBox;
    chk1: TCheckBox;
    passwordreinit: TJvEdit;
    svuota: TButton;
    GroupBox2: TGroupBox;
    Image2: TImage;
    Label5: TLabel;
    Label6: TLabel;
    Label1: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    filesql: TJvFilenameEdit;
    passwordexport: TJvEdit;
    esporta: TButton;
    grpTabelle: TGroupBox;
    chkServizi: TCheckBox;
    chkorari: TCheckBox;
    chkTraportati: TCheckBox;
    chkSoci: TCheckBox;
    chkVolontari: TCheckBox;
    GroupBox3: TGroupBox;
    checkconsistenza: TButton;
    Image3: TImage;
    Label14: TLabel;
    correctpassword: TJvEdit;
    correcterror: TButton;
    Label15: TLabel;
    Label16: TLabel;
    qryCheckSeq: TQuery;
    Memo1: TMemo;
    Label13: TLabel;
    qryRepairSeq: TQuery;
    procedure Button1Click(Sender: TObject);
    procedure CheckExec(Sender: TObject);
    procedure svuotaClick(Sender: TObject);
    procedure SvuotaKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EsportaKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure esportaClick(Sender: TObject);
    procedure checkconsistenzaClick(Sender: TObject);
    procedure correctpasswordKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure correcterrorClick(Sender: TObject);
  private
    procedure ExecSQLCommand(sql : string);
    var
      SchedeMancanti : array of integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmDBDump: TFrmDBDump;

implementation

{$R *.dfm}

uses untauto, untcommon, untmain,dmMod, ShlObj;



resourcestring
  resetComplete = 'Database reinizializzato.';
  exportComplete = 'Tabelle esportate.';
  exportError = 'Errore nell''esportazione, verificare i parametri';
  schedeOk = 'Non sono stati rilevati problemi.';
  schedeKo = 'I numeri di schede non sono sequenziali, si consiglia di correggere l''errore';
  correctOk = 'Errori corretti.';

procedure TFrmDBDump.Button1Click(Sender: TObject);
begin
  close
end;

procedure TFrmDBDump.checkconsistenzaClick(Sender: TObject);
var previsto,i: integer;

begin
  previsto := 1;
  i := 0;
  memo1.Lines.Clear;
  qryCheckSeq.Open;
  qryCheckSeq.First;
  while not(qryCheckSeq.Eof) do
  begin
    if not(qryCheckSeq.FieldByName('num').AsInteger = previsto) then
    begin
     while not(qryCheckSeq.FieldByName('num').AsInteger = previsto) do
     begin
      Memo1.Lines.Add('Manca la scheda numero: ' + inttostr(previsto) + ' (Vicino all''id ' +
        qryCheckSeq.FieldByName('id').AsString + ')');
      if (High(SchedeMancanti) = -1) then
        SetLength(SchedeMancanti, 0 + 1)
      else
        SetLength(SchedeMancanti, i + 1);

      SchedeMancanti[i] := previsto;
      previsto := previsto + 1;
      i := i + 1;
     end;
    end;

    previsto := previsto + 1;

    qryCheckSeq.Next;
  end;
  qryCheckSeq.Close;

  if (Length(SchedeMancanti) = 0) then
    memo1.Lines.Add(SchedeOk)
  else
    memo1.Lines.Add(SchedeKo);

end;

procedure TFrmDBDump.CheckExec(Sender: TObject);
begin
  if chk1.Checked AND chk2.Checked then
  begin
    passwordreinit.Enabled := True;
    passwordreinit.SetFocus;
  end
  else
    passwordreinit.Enabled := False;
    Svuota.Enabled := False;
    
end;

procedure TFrmDBDump.esportaClick(Sender: TObject);
var tables, cmdline: string;
    FMysqlDump : String;
    success : integer;
begin
  FMysqlDump := GetConfString('DBEXPORT','MYSQLDUMP');
  cmdline := '-r "' + FileSQL.FileName + '" -u'+GetConfString('DBEXPORT','USERNAME') +' -p' + GetConfString('DBEXPORT','PASSWORD');
  cmdline := cmdline + ' -h ' + GetConfString('DBEXPORT','DB HOST');
  cmdline := cmdline + ' ' + GetConfString('DATABASE','DATABASE NAME');

  if chkservizi.Checked then
    tables := tables + ModServ.TblServizi.TableName +' ';
  if chkTraportati.Checked then
    tables := tables + ModServ.TblTrasport.TableName +' ';
  if chkorari.Checked then
    tables := tables + ModServ.TblOrariDispo.TableName +' ';
  if chkVolontari.Checked then
    tables := tables + ModServ.TblGestVol.TableName +' ';
  if chksoci.Checked then
    tables := tables + ModServ.TblSoci.TableName +' ';

  cmdline := cmdline + ' ' + tables;

  success := ShellExecute(FrmDBDump.Handle, 'open', PChar(FMysqlDump), PChar(cmdline),
    PChar(ExtractFileDir(FMysqlDump)), SW_HIDE);

  if success > 32 then
    ShowMessage(exportComplete)
  else
    ShowMEssage(exportError);

end;

procedure TFrmDBDump.svuotaClick(Sender: TObject);
begin
{
TRUNCATE servizi;
TRUNCATE trasport;
TRUNCATE sequence;
INSERT INTO sequence (id)
VALUES ('0');
UPDATE sequence SET id='0';
}
    ExecSQLCommand('TRUNCATE ' + ModServ.TblServizi.TableName );
    ModServ.ResetSingleDataset(ModServ.tblServizi);
    ExecSQLCommand('TRUNCATE ' + ModServ.TblTrasport.TableName);
    ModServ.ResetSingleDataset(ModServ.TblTrasport);
    ExecSQLCommand('TRUNCATE sequence');
    ExecSQLCommand('INSERT INTO sequence (id) VALUES ("0")');
    ExecSQLCommand('UPDATE sequence SET id="0"');
    FrmMain.RefreshQuery;
    ShowMessage(resetComplete);
end;

procedure TFrmDBDump.SvuotaKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if CheckPassword(passwordreinit.Text,'ADMIN') then
    svuota.Enabled := True
  else
    svuota.Enabled := False;
end;

procedure TFrmDBDump.ExecSQLCommand(SQL : string);
begin
  QryResetDB.Sql.clear;
  QryResetDB.SQL.ADD(SQL);
  QryResetDB.ExecSQL;
end;

procedure TFrmDBDump.FormCreate(Sender: TObject);
begin
  if GetConfString('DBEXPORT', 'DEFAULT PATH') <> '' then
    filesql.InitialDir := GetConfString('DBEXPORT', 'DEFAULT PATH')
  else
    filesql.InitialDir := GetSpecialFolder(CSIDL_DESKTOPDIRECTORY);

  filesql.FileName := filesql.InitialDir +'\'+ 'db_'+ inttostr(YearOf(now)-1) + '.sql';
end;

procedure TFrmDBDump.correcterrorClick(Sender: TObject);
var i: integer;
begin
  for i := 0 to Length(SchedeMancanti) - 1 do
  begin
    qryRepairSeq.ParamByName('num').AsInteger := SchedeMancanti[i];
    qryRepairSeq.ExecSQL;
  end;
  FrmMain.RefreshQuery;

  ShowMessage(correctOk);

end;

procedure TFrmDBDump.correctpasswordKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if not(Length(SchedeMancanti) = 0) then
  begin
   if CheckPassword(correctpassword.Text,'ADMIN') then
     correcterror.Enabled := True
   else
     correcterror.Enabled := False;
  end;
end;

procedure TFrmDBDump.EsportaKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if CheckPassword(passwordexport.Text,'ADMIN') then
    esporta.Enabled := True
  else
    esporta.Enabled := False;
end;

end.
