unit UntModelli;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,dmMod, Grids, DBGrids, Buttons, StdCtrls, ExtCtrls, DBCtrls, Mask, ComCtrls, Db,
  ActnList, ImgList, untcommon;

type
  TFrmModelli = class(TForm)
    Label6: TLabel;
    Label1: TLabel;
    sbNew: TSpeedButton;
    sbDel: TSpeedButton;
    sbundo: TSpeedButton;
    sbsave: TSpeedButton;
    sbEdit: TSpeedButton;
    sbExit: TSpeedButton;
    Label19: TLabel;
    tot: TLabel;
    PAGESOCI: TPageControl;
    TabSoci: TTabSheet;
    Label17: TLabel;
    edSearch: TEdit;
    tablista: TTabSheet;
    DBGrid1: TDBGrid;
    dtsVolunteer: TDataSource;
    acnModello: TActionList;
    ImageList1: TImageList;
    SpeedButton1: TSpeedButton;
    grpModifica: TGroupBox;
    Label2: TLabel;
    IDENTIFICATIVO: TDBEdit;
    Label27: TLabel;
    NOMEECOGNOME: TDBEdit;
    Label3: TLabel;
    INDIRIZZO: TDBEdit;
    Label20: TLabel;
    PAESE: TDBEdit;
    Label26: TLabel;
    CAP: TDBEdit;
    Label21: TLabel;
    MOTIVO: TDBEdit;
    Label22: TLabel;
    LUOGO: TDBEdit;
    Label23: TLabel;
    LUOGO_CITTA: TDBEdit;
    Label24: TLabel;
    DESTINAZ: TDBEdit;
    Label25: TLabel;
    DESTINAZ_CITTA: TDBEdit;
    Label29: TLabel;
    km: TDBEdit;
    Laberl124: TLabel;
    costo: TDBEdit;
    acnSearch: TAction;
    Label4: TLabel;
    rdiAndata: TRadioButton;
    rdiRitorno: TRadioButton;
    Label5: TLabel;
    RICHIEDENTE: TDBLookupComboBox;
    Label7: TLabel;
    ora_serv: TDBEdit;
    Label8: TLabel;
    ora_fine: TDBEdit;
    chkbolla: TDBCheckBox;
    btnOspedaliFrom: TSpeedButton;
    btnOspedaliTo: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure DBGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure edSearchKeyPress(Sender: TObject; var Key: Char);
    procedure acnSearchExecute(Sender: TObject);
    procedure sbNewClick(Sender: TObject);
    procedure sbEditClick(Sender: TObject);
    procedure sbundoClick(Sender: TObject);
    procedure sbsaveClick(Sender: TObject);
    procedure dtsVolunteerStateChange(Sender: TObject);
    procedure sbExitClick(Sender: TObject);
    procedure sbDelClick(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure dtsVolunteerDataChange(Sender: TObject; Field: TField);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOspedaliFromClick(Sender: TObject);
    procedure btnOspedaliToClick(Sender: TObject);
  private
    procedure disabilita_tab;
    procedure abilita_tab;
    procedure SyncList;
  public
    { Public declarations }
  end;

var
  FrmModelli: TFrmModelli;

implementation

{$R *.dfm}

uses untOspedale, untException;

procedure TFrmModelli.sbNewClick(Sender: TObject);
begin
  abilita_tab;
  Modserv.TblModelli.Append;
  ModServ.TblModelli['bolla'] := FALSE;
  pagesoci.ActivePage := tabsoci;
  Identificativo.SetFocus;
end;

procedure TFrmModelli.sbEditClick(Sender: TObject);
begin
  abilita_tab;
  modserv.TblModelli.edit;
  identificativo.SetFocus;
end;

procedure TFrmModelli.sbundoClick(Sender: TObject);
begin
  if confirm('Annullare le modifiche ?') then
  begin
    disabilita_tab;
    //annullamento dell'inserimento
    Modserv.TblModelli.Cancel;
    //cancellazione cache
    ModServ.TblModelli.CancelUpdates;
  end;
end;

procedure TFrmModelli.sbsaveClick(Sender: TObject);
begin
  disabilita_tab;
  //salvataggio del sesso
  if rdiAndata.Checked then
    ModServ.TblModelli.FieldByName('VIAGGIO').asstring := 'ANDATA'
  else
    ModServ.TblModelli.FieldByName('VIAGGIO').asstring := 'RITORNO';

  //SALVATAGGIO NEL DATABASE
  //INIZIA LA TRANSAZIONE
  ModServ.TblModelli.Post;
  ModServ.Database.StartTransaction;
  try
    //salvo la tabella padre
    ModServ.TblModelli.ApplyUpdates;
    ModServ.TblModelli.CommitUpdates;
    //salvo la transazione
    ModServ.Database.Commit;
    ModServ.qryVolunteerList.Close;
    ModServ.qryVolunteerList.Open;
  except
    on E: Exception do
    begin
      //se c' qualche problema allora avvia la procedura di rollback
      if ModServ.Database.InTransaction then
        ModServ.Database.Rollback;

      FrmException := TFrmException.Create(self);
      FrmException.TextLabel.Text := 'Registrazioni non avvenute per problemi nei database.'#13 +
        'Rivolgersi all'' assistenza tecnica.';
      FrmException.DetailsMemo.Text :=  E.Message;
      FrmException.ShowModal;
      FrmException.Free;
      Abort;
    end;

  end;
end;

procedure TFrmModelli.abilita_tab;
begin
  grpModifica.Enabled := True;
end;

procedure TFrmModelli.disabilita_tab;
begin
  grpModifica.Enabled := False;
end;

procedure TFrmModelli.dtsVolunteerDataChange(Sender: TObject; Field: TField);
begin
  if modserv.TblModelli.State = dsbrowse then
  begin
    if modServ.TblModelli.FieldByName('VIAGGIO').AsString = 'ANDATA' then
      rdiAndata.Checked := true
    else
      rdiRitorno.Checked := true;
  end;

end;

procedure TFrmModelli.dtsVolunteerStateChange(Sender: TObject);
begin
  if modserv.TblModelli.State in [dsedit, dsinsert] then
  begin
    sbnew.enabled := false;
    sbedit.enabled := false;
    sbdel.enabled := false;
    sbundo.enabled := true;
    sbsave.enabled := true;
    sbexit.enabled := false;
  end
  else
  begin
    sbnew.enabled := true;
    if modserv.TblModelli.recordcount > 0 then
    begin
      sbedit.enabled := true;
      sbdel.enabled := true;
    end
    else
    begin
      sbedit.enabled := false;
      sbdel.enabled := false;
    end;
    sbundo.enabled := false;
    sbsave.enabled := false;
    sbexit.enabled := true;
  end;
  tot.Caption := inttostr(modserv.TblModelli.recordcount);
end;

procedure TFrmModelli.sbExitClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmModelli.sbDelClick(Sender: TObject);
begin
  if confirm('Eliminare il record ?') then
  begin
    ModServ.TblModelli.Delete;
    MODSERV.Database.StartTransaction;
    try
      //salvo la tabella padre
      Modserv.TblModelli.ApplyUpdates;
      Modserv.TblModelli.CommitUpdates;
      //salvo la transazione
      ModServ.Database.Commit;
    except
      on E: Exception do
      begin
        //se c' qualche problema allora avvia la procedura di rollback
        if ModServ.Database.InTransaction then
          ModServ.Database.Rollback;
      FrmException := TFrmException.Create(self);
      FrmException.TextLabel.Text := 'Registrazioni non avvenute per problemi nei database.'#13 +
        'Rivolgersi all'' assistenza tecnica.';
      FrmException.DetailsMemo.Text :=  E.Message;
      FrmException.ShowModal;
      FrmException.Free;
        Abort;
      end;
    end;
  end;
end;

procedure TFrmModelli.DBGrid1DblClick(Sender: TObject);
begin
  SyncList;
  pagesoci.ActivePage := tabsoci;
end;

procedure TFrmModelli.acnSearchExecute(Sender: TObject);
begin
  ModServ.TblModelli.Locate('IDENTIFICATIVO', edSearch.Text, [loCaseInsensitive, loPartialKey]);
end;

procedure TFrmModelli.btnOspedaliFromClick(Sender: TObject);
begin
  FrmOspedali := TFrmOspedali.create(self);
  FrmOspedali.OspedaleList.Listsource := ModServ.DsrOspedali;

    if (FrmOspedali.ShowModal = mrYes) then
    begin
      ModServ.TblModelli['luogo'] := ModServ.TblOSpedali['ospedale'];
      ModServ.TblModelli['luogo_citta'] := ModServ.TblOSpedali['paese'];
    end;
  FrmOspedali.free;
end;

procedure TFrmModelli.btnOspedaliToClick(Sender: TObject);
begin
  FrmOspedali := TFrmOspedali.create(self);
  FrmOspedali.OspedaleList.Listsource := ModServ.DsrOspedali;
  
    if (FrmOspedali.ShowModal = mrYes) then
    begin
      ModServ.TblModelli['destinaz'] := ModServ.TblOSpedali['ospedale'];
      ModServ.TblModelli['destinaz_citta'] := ModServ.TblOSpedali['paese'];
    end;
  FrmOspedali.free;
end;

procedure TFrmModelli.edSearchKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    acnSearch.Execute;
    Key := #0;
  end;
end;

procedure TFrmModelli.SyncList;
begin
   ModServ.TblModelli.Locate('id', dbgrid1.Fields[0].Value , []);
end;

procedure TFrmModelli.DBGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    SyncList;
    pagesoci.ActivePage := tabsoci;
  end;
end;

procedure TFrmModelli.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    ModServ.TblCliente.Active := False;
end;

procedure TFrmModelli.FormShow(Sender: TObject);
begin
  ModServ.TblCliente.Active := True;
  DISABILITA_TAB;
  SyncList;
end;

end.
