unit UntStrade;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Controls, Forms,
  ActiveX, OleCtrls, SHDocVw, MSHTML, StdCtrls, ActnList, ComCtrls, ExtCtrls,
  JvExExtCtrls, JvSplitter, Buttons, ImgList, dialogs, dmMod, Menus;

type
  TFrmStrade = class(TForm)
    WebBrowser1: TWebBrowser;
    StatusBar1: TStatusBar;
    info: TPanel;
    ProgressBar1: TProgressBar;
    ActionList1: TActionList;
    StopNavigate: TAction;
    RefreshNavigate: TAction;
    BackNavigate: TAction;
    ForwardNavigate: TAction;
    ImageList1: TImageList;
    btncerca: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Mappe1: TMenuItem;
    Ricaricapagina1: TMenuItem;
    Interrompi1: TMenuItem;
    CloseWin: TAction;
    grpDestinaz: TGroupBox;
    Label1: TLabel;
    to_via: TEdit;
    LblComune: TLabel;
    to_comune: TEdit;
    rdiPercorso: TRadioButton;
    rdiPunto: TRadioButton;
    Label9: TLabel;
    grpPartenza: TGroupBox;
    LblPartenzaVia: TLabel;
    da_via: TEdit;
    LblPartenzaComune: TLabel;
    da_comune: TEdit;
    chksede: TCheckBox;
    grpOrtelio: TGroupBox;
    lblcoordinate: TLabel;
    lblTavOrtelio: TLabel;
    LblLatitudine: TLabel;
    LBLLongitudine: TLabel;
    rovaSede1: TMenuItem;
    acnTrovaSede: TAction;
    TrovaColonnina1: TMenuItem;
    TrovaOspedale1: TMenuItem;
    Latitudine: TLabel;
    Longitudine: TLabel;
    procedure SendToNavigate(search : string);
    procedure IndividuaSuMappa(comune : string; indirizzo : string);
    procedure CalcolaPercorso(partenza_comune : string; partenza_indirizzo : string;
      destinazione_comune : string; destinazione_indirizzo : string);
    procedure IndividuaCoordinate(Mylatitudine, Mylongitudine : string);
    procedure WebBrowser1ProgressChange(ASender: TObject; Progress,
      ProgressMax: Integer);
    procedure WebBrowser1BeforeNavigate2(ASender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure WebBrowser1DocumentComplete(ASender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StopNavigateExecute(Sender: TObject);
    procedure RefreshNavigateExecute(Sender: TObject);
    procedure BackNavigateExecute(Sender: TObject);
    procedure ForwardNavigateExecute(Sender: TObject);
    procedure btncercaClick(Sender: TObject);
    procedure to_comuneKeyPress(Sender: TObject; var Key: Char);
    procedure rdiPercorsoClick(Sender: TObject);
    procedure rdiPuntoClick(Sender: TObject);
    procedure chksedeClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CloseWinExecute(Sender: TObject);
    procedure acnTrovaSedeExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
  protected
    procedure CreateParams(var Params: TCreateParams) ; override;
  private
    procedure PopolateMenuMappe;
    procedure LocalizzaColonnina(Sender: TObject);
    procedure LocalizzaOspedale(Sender: TObject);
  public
//     constructor create (Aowner : TComponent); override;
  end;

var
  FrmStrade: TFrmStrade;
  HookID: THandle;

implementation

{$R *.dfm}

uses untcommon;

function MouseProc(nCode: Integer; wParam, lParam: Longint): Longint; stdcall;
var
  szClassName: array[0..255] of Char;
const
  ie_name = 'Internet Explorer_Server';
begin
  case nCode < 0 of
    True:
      Result := CallNextHookEx(HookID, nCode, wParam, lParam)
      else
        case wParam of
          WM_RBUTTONDOWN,
          WM_RBUTTONUP:
            begin
              GetClassName(PMOUSEHOOKSTRUCT(lParam)^.HWND, szClassName, SizeOf(szClassName));
              if lstrcmp(@szClassName[0], @ie_name[1]) = 0 then
                Result := HC_SKIP
              else
                Result := CallNextHookEx(HookID, nCode, wParam, lParam);
            end
            else
              Result := CallNextHookEx(HookID, nCode, wParam, lParam);
        end;
  end;
end;


procedure TFrmStrade.acnTrovaSedeExecute(Sender: TObject);
begin
          IndividuaSuMappa(ModServ.BASECOMUNE,ModServ.BASEINDIRIZZO);
end;

procedure TFrmStrade.BackNavigateExecute(Sender: TObject);
begin
  WebBrowser1.GoBack;
end;

procedure TFrmStrade.btncercaClick(Sender: TObject);
begin
      if rdiPercorso.Checked = true then
      begin
        if (da_comune.Text = '') or (da_via.text = '') then
        begin
          MessageDlg('Inserire un luogo di partenza valido.', mtWarning,
          [mbOk], 0);
          Abort;
        end
        else
         CalcolaPercorso(da_comune.text,da_via.Text,
         to_comune.text,to_via.Text);
      end
      else
      begin
      if (to_comune.Text = '') or (to_via.text = '') then
        begin
          MessageDlg('Inserire una destinazione valida.', mtWarning,
          [mbOk], 0);
          Abort;
        end
        else
        IndividuaSuMappa(to_comune.Text,to_via.Text);
      end;
end;

procedure TFrmStrade.CalcolaPercorso(partenza_comune, partenza_indirizzo,
  destinazione_comune: string; destinazione_indirizzo : string);
  var searchurl : string;
begin

    Latitudine.Caption := '';
    Longitudine.caption := '';

    da_comune.Text := partenza_comune;
    da_via.text := partenza_indirizzo;
    to_comune.text := destinazione_comune;
    to_via.text := destinazione_indirizzo;

    rdiPunto.Checked := False;
    rdiPercorso.Checked := True;
    rdiPercorsoClick(self);
    
    //http://maps.google.com/maps?f=d&hl=it&geocode=&saddr=cesate+via+venezia+31
    //&daddr=Via+Kennedy,+20020+Cesate+Milano,+Lombardia,+Italia&mra=pe&mrcr=0
    //&sll=45.591424,9.071946&sspn=0.010886,0.021372&ie=UTF8&t=h&z=17
    searchurl := ModServ.PARTENZA + PARTENZA_INDIRIZZO + '+' + PARTENZA_COMUNE +
       ModServ.DESTINAZIONE + DESTINAZIONE_INDIRIZZO + '+' + DESTINAZIONE_COMUNE;
    SendToNavigate(searchurl);
end;

procedure TFrmStrade.chksedeClick(Sender: TObject);
begin
    if chksede.Checked = True then
      begin
        da_via.Text := ModServ.BASEINDIRIZZO;
        da_comune.Text := ModServ.BASECOMUNE;
        da_via.Enabled := False;
        da_comune.Enabled := False;
      end
      else
      begin
        da_via.Enabled := True;
        da_comune.Enabled := True;
        da_via.Text := '';
        da_comune.text := '';
      end;
end;

//constructor TFrmStrade.create(Aowner: TComponent);
//begin
//  inherited Create(AOwner);
//end;

procedure TFrmStrade.CloseWinExecute(Sender: TObject);
begin
  Close;
end;

procedure TFrmStrade.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
  Params.WndParent := GetDesktopWindow;
end;

procedure TFrmStrade.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WebBrowser1.Navigate('About:blank');
  rdiPuntoClick(self);
  chksede.Checked := false;
  rdiPunto.Checked := True;
  da_via.text := '';
  da_comune.text := '';
  to_via.text := '';
  to_comune.text := '';
  Latitudine.Caption := '';
  Longitudine.Caption := '';
end;

procedure TFrmStrade.FormCreate(Sender: TObject);
begin
  HookID := SetWindowsHookEx(WH_MOUSE, MouseProc, 0, GetCurrentThreadId());
  PopolateMenuMappe;
end;

procedure TFrmStrade.FormDestroy(Sender: TObject);
begin
  if HookID <> 0 then
    UnHookWindowsHookEx(HookID);
end;

procedure TFrmStrade.FormResize(Sender: TObject);
  var X,Y : integer;
begin

  X := ( WebBrowser1.Width div 2);

  grpDestinaz.Width := X-5;
  Y := (grpDestinaz.Width div 2);

  // Sistemo la roBBe dentro alla groupbox Destinazione
  lblComune.left := Y+10;
  rdiPercorso.left := Y+10;
  to_comune.Left := lblComune.left+lblComune.Width+10;


  grpPartenza.Left := X;
  grpOrtelio.Left := X;
  grpPartenza.Width := X;
  grpOrtelio.Width := X;

  // Sistemo la roba dentro la groupbox partenza e ortelio
  Y := (grpPartenza.Width div 2);
  LblPartenzaVia.Left := 10;
  da_via.Left := 10 + LblPartenzaVia.Width + 10;
  chksede.left := da_via.left;
  LblPartenzaComune.Left := Y;
  da_comune.Left := (Y + LblPartenzaComune.Width + 10);

  lblTavOrtelio.left := 10;
  lblLatitudine.left := 10;

  lblcoordinate.Left := Y;
  LBLLongitudine.Left := Y;

  Latitudine.Left := lblLatitudine.left + LblLatitudine.Width + 5;
  Longitudine.left := LBLLongitudine.left + LBLLongitudine.Width + 5;




end;

procedure TFrmStrade.ForwardNavigateExecute(Sender: TObject);
begin
  WebBrowser1.GoForward;
end;

procedure TFrmStrade.IndividuaCoordinate(Mylatitudine, Mylongitudine : string);
  var searchurl : string;
begin
    searchurl := ModServ.COORD + Mylatitudine + ',' + Mylongitudine;
    Latitudine.Caption := Mylatitudine;
    Longitudine.caption := Mylongitudine;
    SendToNavigate(searchurl);
end;

procedure TFrmStrade.IndividuaSuMappa(comune, indirizzo: string);
  var searchurl: string;
begin
    to_comune.text := comune;
    to_via.text := indirizzo;
    Latitudine.Caption := '';
    Longitudine.caption := '';

// http://maps.google.com/maps?f=q&hl=it&geocode=&q=cesate+via+venezia+31&sll=37.0625,-95.677068&sspn=48.15347,87.539063&ie=UTF8&ll=45.589266,9.070126&spn=0.005443,0.010686&t=h&z=17&iwloc=addr
   searchurl := ModServ.INDIVIDUA + indirizzo + '+' + comune;
   SendToNavigate(searchurl);
end;

procedure TFrmStrade.rdiPercorsoClick(Sender: TObject);
begin
    grpPartenza.Visible := True;
    grpPartenza.Align := AlNone;
    grpOrtelio.Visible := False;
    grpOrtelio.Align := AlRight;

    FormResize(nil)

end;

procedure TFrmStrade.rdiPuntoClick(Sender: TObject);
begin
    grpPartenza.Visible := False;
    grpPArtenza.Align := AlRight;
    grpOrtelio.Visible := True;
    grpOrtelio.Align := AlNone;

    FormResize(nil);
end;

procedure TFrmStrade.RefreshNavigateExecute(Sender: TObject);
begin
    WebBrowser1.Refresh;
end;

procedure TFrmStrade.SendToNavigate(search : string);
begin
  WebBrowser1.Navigate(ModServ.MAPPEURL + search);
end;

procedure TFrmStrade.StopNavigateExecute(Sender: TObject);
begin
    WebBrowser1.Stop;
end;

procedure TFrmStrade.to_comuneKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
    btnCercaClick(self);
end;

procedure TFrmStrade.WebBrowser1BeforeNavigate2(ASender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
begin
  ProgressBar1.Position := 0;
  StatusBar1.Panels[1].Text := URL;
end;

procedure TFrmStrade.WebBrowser1DocumentComplete(ASender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
   StatusBar1.Panels[1].Text := 'Pagina caricata';
end;

procedure TFrmStrade.WebBrowser1ProgressChange(ASender: TObject; Progress,
  ProgressMax: Integer);
begin
  if Progress>0 then
  begin
    ProgressBar1.Max := ProgressMax;
    ProgressBar1.Position := Progress
  end { Progress>0 }
  else
    ProgressBar1.Min := 0
end;

procedure TFrmStrade.LocalizzaColonnina(Sender: TObject);
  var  MyCoordinate : TCoordinate;
begin

       MyCoordinate := GetCoordinate('colonnine','colonnina',
       StringReplace((sender as TMenuItem).Caption,'&','',[rfReplaceAll, rfIgnoreCase]));

       if (MyCoordinate[1] = '') or(MyCoordinate[2] = '') then
       begin
        MessageDlg('coordinate non valide, impossibile continuare',
        mtWarning, [mbOk], 0);
       end
       else
       begin

        FrmStrade.IndividuaCoordinate(MyCoordinate[1],MyCoordinate[2]);

       end;
end;

procedure TFrmStrade.LocalizzaOspedale(Sender: TObject);
  var  MyCoordinate : TCoordinate;
begin

       MyCoordinate := GetCoordinate('ospedali','ospedale',
       StringReplace((sender as TMenuItem).Caption,'&','',[rfReplaceAll, rfIgnoreCase]));

       if (MyCoordinate[1] = '') or(MyCoordinate[2] = '') then
       begin
        MessageDlg('coordinate non valide, impossibile continuare',
        mtWarning, [mbOk], 0);
       end
       else
       begin

        FrmStrade.IndividuaCoordinate(MyCoordinate[1],MyCoordinate[2]);

       end;
end;

procedure TFrmStrade.PopolateMenuMappe;
var
  mi: TMenuItem;
begin
  ModServ.QryFind.SQL.Clear;
  ModServ.QryFind.SQL.Add('select colonnina from colonnine order by colonnina');
  ModServ.QryFind.Open;
  ModServ.QryFind.First;
  while not (ModServ.QryFind.Eof) do
  begin
    mi := TMenuItem.Create(MainMenu1);
    mi.Caption := CapitaliseString(ModServ.QryFind.FieldByName('colonnina').AsString, True);
    mi.OnClick := LocalizzaColonnina;
    TrovaColonnina1.Add(mi);
    ModServ.QryFind.Next;
  end;
  ModServ.QryFind.Close;
  ModServ.QryFind.SQL.Clear;
  ModServ.QryFind.SQL.Add('select ospedale from ospedali order by ospedale');
  ModServ.QryFind.Open;
  ModServ.QryFind.First;
  while not (ModServ.QryFind.Eof) do
  begin
    mi := TMenuItem.Create(MainMenu1);
    mi.Caption := CapitaliseString(ModServ.QryFind.FieldByName('ospedale').AsString, True);
    mi.OnClick := LocalizzaOspedale;
    TrovaOspedale1.Add(mi);
    ModServ.QryFind.Next;
  end;
  ModServ.QryFind.Close;
  ModServ.QryFind.SQL.Clear;
end;


end.
