unit UntTrasportato;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  dmMod, dmServizi, ExtCtrls, StdCtrls, Grids, DBGrids, DBCtrls, Mask, Buttons,
  ActnList, ImgList, ShlIntf, ActiveX, ComObj, StrTools;

type
  TFrmCaricato = class(TForm)
    pnlFooter: TPanel;
    pnlTransportData: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    edName: TDBEdit;
    edAddress: TDBEdit;
    edCAP: TDBEdit;
    edBirthDate: TDBEdit;
    edCity: TDBEdit;
    chkAssociate: TDBCheckBox;
    Label6: TLabel;
    Label7: TLabel;
    Label25: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    btnNew: TSpeedButton;
    btnDelete: TSpeedButton;
    btnUndo: TSpeedButton;
    btnSave: TSpeedButton;
    grdTransported: TDBGrid;
    btnBack: TBitBtn;
    aclTransported: TActionList;
    imlTransported: TImageList;
    acnNew: TAction;
    acnDelete: TAction;
    acnUndo: TAction;
    acnSave: TAction;
    acnBack: TAction;
    constructor CreateWithDM(AOwner: TComponent; d: TdmdServizi);
    procedure acnBackExecute(Sender: TObject);
    procedure acnDeleteUpdate(Sender: TObject);
    procedure acnNewUpdate(Sender: TObject);
    procedure acnSaveUpdate(Sender: TObject);
    procedure acnSaveExecute(Sender: TObject);
    procedure acnUndoExecute(Sender: TObject);
    procedure acnDeleteExecute(Sender: TObject);
    procedure acnNewExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Completamento(CampoForm: TDBedit; ColonnaDB : string);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    FAutoComplete: IAutoComplete2;
    FStrings: IUnknown;
    qryresult: TstringList;
    FdmServizi: TdmdServizi;
  public
    { Public declarations }
  end;

var
  FrmCaricato: TFrmCaricato;
  Var CheckSave : Integer = 0;
  // 0 = NotSaved
  // 1 = Saved
  // 2 = Annullato/Altro


implementation

{$R *.DFM}

uses
  DB;

constructor TFrmCaricato.CreateWithDM(AOwner: TComponent; d: TdmdServizi);
begin
  inherited Create(AOwner);
  FdmServizi := d;
  RedirectFixupReferences(Self, 'dmdServizi', FdmServizi.Name);
end;

procedure TFrmCaricato.Completamento(CampoForm: TDBedit; ColonnaDB : string);
var
  qrystring: string;

begin
  qryresult := TStringList.Create;

  qrystring := Format('select %s from trasport group by %s;', [ColonnaDB,ColonnaDB]);

  FDmServizi.QryFind.Close;
  FDmServizi.QryFind.SQL.Clear;
  FDmServizi.QryFind.SQL.Add(qrystring);
  FDmServizi.QryFind.Open;

  while not FDmServizi.QryFind.EOF do begin
    qryresult.Add(FDmServizi.QryFind.FieldByName(ColonnaDB).AsString);
    FDmServizi.QryFind.Next;
  end;

  FDmServizi.QryFind.Close;

  // AUTOCOMPLETE
  FAutoComplete := CreateComObject(CLSID_AutoComplete) as IAutoComplete2;
  FStrings := TEnumString.Create(qryresult) as IUnknown;
  OleCheck(FAutoComplete.SetOptions(ACO_AUTOAPPEND or ACO_AUTOSUGGEST or ACO_UPDOWNKEYDROPSLIST));
  OleCheck(FAutoComplete.Init(CampoForm.handle, FStrings, nil, nil));

end;

procedure TFrmCaricato.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    if modserv.AUTOCOMPLETE then
      qryresult.free;
end;

procedure TFrmCaricato.FormShow(Sender: TObject);
begin
  // Per non sbagliare setto a cazzo il check
  CheckSave := 3;
  
  if modserv.AUTOCOMPLETE then
  begin
    Completamento(FrmCaricato.edName, FrmCaricato.edName.DataField);
    Completamento(FrmCaricato.edAddress, FrmCaricato.edAddress.DataField);
    Completamento(FrmCaricato.edCity, FrmCaricato.edCity.DataField);
  end;

  if FDmServizi.TblTrasport.IsEmpty then
    begin
      acnNew.Execute;
    end;
end;

procedure TFrmCaricato.acnNewExecute(Sender: TObject);
begin
  FDmServizi.TblTrasport.Insert;
  //abilitazione socio
  FDmServizi.TblTrasport.FieldByName('SOCIO').AsInteger := 0;
  // Setto a zero il check
  CheckSave := 0;
  //posizionamento del mouse nel campo del nominativo
  edname.SetFocus;
end;

procedure TFrmCaricato.acnDeleteExecute(Sender: TObject);
begin
  CheckSave := 2;
  FDmServizi.TblTrasport.Delete;
end;

procedure TFrmCaricato.acnUndoExecute(Sender: TObject);
begin
  //annullamento dell'inserimento
  CheckSave := 2;
  FDmServizi.TblTrasport.Cancel;
end;

procedure TFrmCaricato.acnSaveExecute(Sender: TObject);
begin
  CheckSave := 1;
  FDmServizi.TblTrasport.Post;
end;

procedure TFrmCaricato.acnSaveUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := FDmServizi.TblTrasport.State in
    [dsEdit, dsInsert];
end;

procedure TFrmCaricato.acnNewUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := not (FDmServizi.TblTrasport.State in
    [dsEdit, dsInsert]);
end;

procedure TFrmCaricato.acnDeleteUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := not FDmServizi.TblTrasport.IsEmpty;
end;

procedure TFrmCaricato.acnBackExecute(Sender: TObject);
begin
  //controllo se sono stati inseriti almeno il paziente trasportato
  //e non si tratta di stazionamento
  if (CheckSave = 0) then
  begin
    MessageDlg('Inserire tutti i dati della persona trasportata oppure annullare il trasportato.', mtError,
      [mbCancel], 0);
    Abort;
  end;
  Close;
end;

end.
